#include <stdio.h>
#include <stdlib.h>
#include "piece.h"
#include "game.h"

int main() {
    char move;
    int piece_number;
    bool game_over;
    bool valid_movement;
    dir direction;
    int distance;
    piece tab_piece[] = {new_piece_rh(1, 3, true, true), new_piece_rh(3, 3,false, false), new_piece_rh(1, 1, true, false), new_piece_rh(3, 2, false, true)};
    game g = new_game_hr(4, tab_piece); //4 est le nombre de pièces dans le tableau de pièces 
    game_over = game_over_hr(g);
    printBoard(g); // on affiche la grille au début du jeu
    while(!game_over) {
        printf("Veuillez choisir le numero de la piece a deplacer: \n");
        scanf("%d", &piece_number);
	while(piece_number > 4 || piece_number == 4) { //on vérifie le véhicule désirée
	     printf("Ceci n'est pas un véhicule valide, veuillez choisir un autre véhicule \n");
	     scanf("%d", &piece_number);
	}
        printf("Vous avez choisi de déplacer la voiture n° %d\n" , piece_number);
        printf("Veuillez choisir une direction : l r u d \n");
        scanf("\n%c", &move);
        while (move != '\0' && move != 'l' && move != 'r' && move != 'd' && move != 'u') { // on vérifie la direction souhaitée
            printf("Ceci n'est pas une direction valide, veuillez choisir une direction : UP(u) DOWN(d) LEFT(l) RIGHT(r) \n");
            scanf("\n%c", &move);
        }
        if (move == 'u')
            direction = UP;
	
        if (move == 'd')
            direction = DOWN;
	
        if (move == 'l')
            direction = LEFT;
	
        if (move == 'r')
            direction = RIGHT;

	printf("Veuillez entrer une distance \n");
        scanf("\n%d", &distance);
	
        valid_movement = play_move(g, piece_number, direction, distance);
        if (!valid_movement)
            printf("Le choix du mouvement est invalide\n");
        game_over = game_over_hr(g);
	printBoard(g); //on affiche la grille après le mouvement
    }
    delete_game(g);
    //on libère les pièces de notre tableau des pieces
    for(int i = 0; i < 4; ++i)
      free(tab_piece[i]);
    return EXIT_SUCCESS;
}
